function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["iconSize", "align", "direction", "value", "list"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useRef, forwardRef, useImperativeHandle } from 'react';
import StepHorizontalCenter from "./StepHorizontalCenter";
import StepHorizontalLeft from "./StepHorizontalLeft";
import StepVerticalCenter from "./StepVerticalCenter";
import StepVerticalLeft from "./StepVerticalLeft";

// 内库使用-start
import DOMUtil from "./../../utils/DOMUtil";
// 内库使用-end

/* 测试使用-start
import { DOMUtil } from 'seedsui-react'
测试使用-end */

// 步骤条
var Steps = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$iconSize = _ref.iconSize,
    iconSize = _ref$iconSize === void 0 ? 8 : _ref$iconSize,
    _ref$align = _ref.align,
    align = _ref$align === void 0 ? 'center' : _ref$align,
    _ref$direction = _ref.direction,
    direction = _ref$direction === void 0 ? 'vertical' : _ref$direction,
    value = _ref.value,
    list = _ref.list,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);

  // Expose
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });

  // 获取每项的状态
  function getItemStatus(item, index) {
    // 没有索引, 也没有id, 则没有选中项
    if (typeof (value === null || value === void 0 ? void 0 : value.index) !== 'number' && !(value !== null && value !== void 0 && value.id)) return 'wait';
    var activeStatus = (value === null || value === void 0 ? void 0 : value.status) || 'active';

    // 根据id判断选中项
    if (value !== null && value !== void 0 && value.id) {
      if ((item === null || item === void 0 ? void 0 : item.id) === (value === null || value === void 0 ? void 0 : value.id)) {
        value.activeIndex = index;
        return activeStatus;
      }
      if (!(value !== null && value !== void 0 && value.activeIndex)) {
        return 'finish';
      }
      return 'wait';
    }

    // 根据索引判断选中项
    if (typeof (value === null || value === void 0 ? void 0 : value.index) === 'number') {
      return index < value.index ? 'finish' : value.index === index ? 'active' : 'wait';
    }
  }

  // 获取Step
  function getStepNode(item, index, params) {
    if (direction === 'vertical') {
      if (align === 'center') {
        return /*#__PURE__*/React.createElement(StepVerticalCenter, _extends({
          key: index
        }, params));
      }
      if (align === 'left') {
        return /*#__PURE__*/React.createElement(StepVerticalLeft, _extends({
          key: index
        }, params));
      }
    }
    if (direction === 'horizontal') {
      if (align === 'center') {
        return /*#__PURE__*/React.createElement(StepHorizontalCenter, _extends({
          key: index
        }, params));
      }
      if (align === 'left') {
        return /*#__PURE__*/React.createElement(StepHorizontalLeft, _extends({
          key: index
        }, params));
      }
    }
    return null;
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    style: _objectSpread(_objectSpread({}, props === null || props === void 0 ? void 0 : props.style), {}, {
      '--steps-title-height': typeof iconSize === 'number' && iconSize > 24 ? iconSize + 'px' : '24px',
      '--steps-icon-size': typeof iconSize === 'number' ? iconSize + 'px' : '8px'
    }),
    className: DOMUtil.classNames('steps', props.className, align ? "steps-".concat(align) : 'steps-center', direction ? "steps-".concat(direction) : 'steps-vertical'),
    ref: rootRef
  }), Array.isArray(list) && list.map(function (item, index) {
    return getStepNode(item, index, {
      iconChildren: iconSize >= 24 ? '' + index : '',
      icon: item === null || item === void 0 ? void 0 : item.icon,
      rail: index < list.length - 1,
      status: (item === null || item === void 0 ? void 0 : item.status) || getItemStatus(item, index),
      title: item === null || item === void 0 ? void 0 : item.title,
      description: item === null || item === void 0 ? void 0 : item.description
    });
  }));
});
export default Steps;